/*
 *   Copyright (c) 1998 T. Kamei (kamei@jsdlab.co.jp)
 *
 *   Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose is hereby granted provided
 * that the above copyright notice and this permission notice appear
 * in all copies of the software and related documentation.
 *
 *                          NO WARRANTY
 *
 *   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY WARRANTIES;
 * WITHOUT EVEN THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS
 * FOR A PARTICULAR PURPOSE.
 */

#ifndef _CMDLINE_H_
#define _CMDLINE_H_

#define ERROR_ENOUGH_MEMORY		0x801E
#define ERROR_RESPONSE_READ		0x802A

class mapf
{
	HANDLE mf_hf;
	HANDLE mf_hm;
	DWORD mf_size;
	void *mf_base;
	
	void init ()
	{
		mf_hf = INVALID_HANDLE_VALUE;
		mf_hm = 0;
		mf_base = 0;
		mf_size = 0;
	}
	
public:
	mapf () {init ();}
	~mapf () {close ();}
	void close ();
	int open (const char *, int = FILE_FLAG_SEQUENTIAL_SCAN);
	const void *base () const {return mf_base;}
	DWORD size () const {return mf_size;}
	operator HANDLE () const {return mf_hf;}
};

class cmdline
{
	int cl_ac;
	char **cl_av;
	int cl_max;
	
	static char *copyarg (const u_char *, const u_char *, int);
	void discard ();
public:
	cmdline () : cl_ac (0), cl_av (0), cl_max (0) {}
	~cmdline () {discard ();}
	int parse (const char *, int, int);
	int parse (const char *s, int r) {return parse (s, s ? strlen (s) : 0, r);}
	int argc () const {return cl_ac;}
	char **argv () const {return cl_av;}
};

#endif /* _CMDLINE_H_ */
